## nomacs-0.4.0-source.zip

=== CMakeLists.txt ===
# usage:
# cd nomacs/root/dir
# mkdir build
# cd build
# cmake ../ImageLounge -DCMAKE_INSTALL_PREFIX=../release -DCMAKE_BUILD_TYPE=debug (or release, by default)
#       on windows there should be -G "generator name" required as well...
# make
# make install
#
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0)

project(nomacs)


OPTION (ENABLE_RAW "Compile with raw images support (OpenCV, libraw)" ON)


set(NOMACS_VERSION 0.4.0)
add_definitions(-DNOMACS_VERSION="${NOMACS_VERSION}")

if (CMAKE_BUILD_TYPE STREQUAL "debug" OR CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    message(STATUS "A debug build. -DDEBUG is defined")
    add_definitions(-DDEBUG)
elseif (NOT MSVC) # debug and release need qt debug outputs on windows
    message(STATUS "A release build (non-debug). Debugging outputs are silently ignored.")
    add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif ()


#Set the custom CMake module directory where our include/lib finders are
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

IF(MSVC)
	file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/libs)
	file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Debug)
	file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Release)
	file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ReallyRelease)	
ENDIF(MSVC)

#set(BUILD_EXAMPLES OFF CACHE BOOL "Build all examples")

# find the Qt
set(QT_MIN_VERSION "4.7.0")
set(QT_USE_GUI 1)
set(QT_USE_QTNETWORK 1)
find_package(Qt4 REQUIRED QtCore QtGui QtNetwork)
include(${QT_USE_FILE})

find_package(PkgConfig)
#IF (NOT PkgConfig_FOUND AND NOT MSVC)
#	message(FATAL_ERROR "PkgConfig not found")
#ENDIF()


# exiv2
pkg_check_modules(EXIV2  exiv2>=0.20)
message(STATUS "exiv2 version by pkg-config: ${EXIV2_VERSION}")
IF (NOT EXIV2_FOUND AND MSVC)

	find_path(EXIV2_BUILD_PATH NAMES "ReleaseDLL/exiv2.lib"
										"ReleaseDLL/exib2.dll"
										"DebugDLL/exiv2d.lib"
										"DebugDLL/exiv2d.dll"
					PATHS "../exiv2-0.21.1/msvc/bin/" 
					DOC "Path to the exiv2 build directory" NO_DEFAULT_PATH)
					
	find_path(EXIV2_INCLUDE_DIRS "exiv2/exiv2.hpp" PATHS "exiv2-0.21.1/msvc/include" DOC "Path to exiv2/exiv2.hpp" NO_DEFAULT_PATH)

	find_path(EXPAT_BUILD_PATH NAMES "release/libexpat.dll" "debug/libexpatd.dll" PATHS "../expat-2.0.1/win32/bin/" DOC "Path to the expat build directory" NO_DEFAULT_PATH)
	
	find_path(ZLIB_BUILD_PATH NAMES "Win32_DLL_Release/zlib1.dll" "Win32_DLL_Debug/zlib1d.dll" PATHS "../zlib-1.2.3/projects/visualc6/" DOC "Path to the zlib build directory" NO_DEFAULT_PATH)
	
    IF(  EXISTS ${EXIV2_BUILD_PATH}/ReleaseDLL/exiv2.dll AND
		EXISTS ${EXIV2_BUILD_PATH}/DebugDLL/exiv2d.dll AND 
		EXISTS ${EXIV2_BUILD_PATH}/ReleaseDLL/exiv2.lib AND 
		EXISTS ${EXIV2_BUILD_PATH}/DebugDLL/exiv2d.lib)
		IF( EXISTS ${EXPAT_BUILD_PATH}/Release/libexpat.dll AND 
			EXISTS ${EXPAT_BUILD_PATH}/Debug/libexpatd.dll)
			IF( EXISTS ${ZLIB_BUILD_PATH}/Win32_DLL_Release/zlib1.dll AND
				EXISTS ${ZLIB_BUILD_PATH}/Win32_DLL_Debug/zlib1d.dll )
		
				FILE(COPY ${EXIV2_BUILD_PATH}/ReleaseDLL/exiv2.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release)
				FILE(COPY ${EXIV2_BUILD_PATH}/ReleaseDLL/exiv2.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/ReallyRelease)
				FILE(COPY ${EXIV2_BUILD_PATH}/ReleaseDLL/exiv2.lib DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/libs)
				FILE(COPY ${EXIV2_BUILD_PATH}/DebugDLL/exiv2d.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug)
				FILE(COPY ${EXIV2_BUILD_PATH}/DebugDLL/exiv2d.lib DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/libs)

				FILE(COPY ${EXPAT_BUILD_PATH}/Release/libexpat.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release)
				FILE(COPY ${EXPAT_BUILD_PATH}/Release/libexpat.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/ReallyRelease)
				FILE(COPY ${EXPAT_BUILD_PATH}/Debug/libexpatd.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug)

				FILE(COPY ${ZLIB_BUILD_PATH}/Win32_DLL_Release/zlib1.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release)
				FILE(COPY ${ZLIB_BUILD_PATH}/Win32_DLL_Release/zlib1.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/ReallyRelease)
				FILE(COPY ${ZLIB_BUILD_PATH}/Win32_DLL_Debug/zlib1d.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug)
				
				SET(EXIV2_LIBRARIES optimized exiv2.lib debug exiv2d.lib)
				SET(EXIV2_LIBRARY_DIRS "")
				SET(EXIV2_FOUND true)
			ELSE ()
				message(WARNING "zlib build directory not found. Needs path which contains Win32_DLL_Release/zlib1.dll and Win32_DLL_Debug/zlib1d.dll")
			ENDIF()
		ELSE()
			message(WARNING "expat build directory not found. Needs path which contains Release/libexpat.dll and Debug/libexpatd.dll")
		ENDIF()
	ELSE()
		message(WARNING "exiv build directory not found. Needs path which contains ReleaseDLL/exiv2.dll, ReleaseDLL/exiv2.lib, DebugDLL/exiv2d.dll and DebugDLL/exiv2d.lib")
	ENDIF()	
	
ENDIF()

find_file(HAVE_EXIV2_HPP exiv2/exiv2.hpp ${EXIV2_INCLUDE_DIRS})
if (HAVE_EXIV2_HPP)
	message(STATUS "exiv2 contains exiv2.hpp, using it")
	add_definitions(-DHAVE_EXIV2_HPP)
else (HAVE_EXIV2_HPP)
	message(STATUS "exiv2 does not contain exiv2.hpp. Using older include set")
endif (HAVE_EXIV2_HPP)


IF (${ENABLE_RAW})

	# NOTE: libraw is used only when there is OpenCV found and used
	# LibRaw
	pkg_check_modules(LIBRAW  libraw>=0.12.0)
        IF (NOT LIBRAW_FOUND AND NOT MSVC)
                message(FATAL_ERROR "libraw not found. It's mandatory when used with ENABLE_RAW enabled") 
        ENDIF()
	IF (NOT LIBRAW_FOUND AND MSVC)
        	find_path(LIBRAW_INCLUDE_DIRS "libraw/libraw.h" PATHS "LibRaw-0.1.3.5" DOC "Path to libraw/libraw.h" NO_DEFAULT_PATH)

        	find_path(LIBRAW_BUILD_PATH NAMES "release/libraw.lib" "release/libraw.dll" "debug/librawd.lib" "debug/librawd.dll"
        	                            PATHS "../LibRaw-0.13.5/buildfiles/" DOC "Path to the libraw build directory" NO_DEFAULT_PATH)

	        IF( EXISTS ${LIBRAW_BUILD_PATH}/release/libraw.dll AND
                	EXISTS ${LIBRAW_BUILD_PATH}/debug/librawd.dll AND 
        	        EXISTS ${LIBRAW_BUILD_PATH}/release/libraw.lib AND 
	                EXISTS ${LIBRAW_BUILD_PATH}/debug/librawd.lib)

                	FILE(COPY ${LIBRAW_BUILD_PATH}/release/libraw.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release)
        	        FILE(COPY ${LIBRAW_BUILD_PATH}/release/libraw.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/ReallyRelease)
	                FILE(COPY ${LIBRAW_BUILD_PATH}/release/libraw.lib DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/libs)
                	FILE(COPY ${LIBRAW_BUILD_PATH}/debug/librawd.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug)
        	        FILE(COPY ${LIBRAW_BUILD_PATH}/debug/librawd.lib DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/libs)

	                SET(LIBRAW_LIBRARY_DIRS "")
                	SET(LIBRAW_LIBRARIES optimized libraw.lib debug librawd.lib)

                	SET(LIBRAW_FOUND true)
                	SET(LIBRAW_VERSION 0.13.5)
        	ELSE()
                	message(WARNING "libraw build directory not found. Needs path which contains release/libraw.dll, release/libraw.lib, debug/librawd.dll and debug/librawd.lib")
        	ENDIF()
	ENDIF()
    IF (LIBRAW_VERSION VERSION_GREATER 0.14.0 OR LIBRAW_VERSION VERSION_EQUAL 0.14.0 )
      add_definitions(-DLIBRAW_VERSION_14)
    endif()
	          
	# OpenCV
	pkg_check_modules(OpenCV  opencv>=2.1.0)
	SET(OpenCV_LIBS ${OpenCV_LIBRARIES})
	If (OpenCV_LIBS STREQUAL "") 
		find_package(OpenCV 2.1.0 REQUIRED core imgproc)
		if (OpenCV_VERSION VERSION_LESS 2.4.0 AND OpenCV_FOUND) # OpenCV didn't allow to define packages before version 2.4.0 ... nomacs was linking against all libs even if they were not compiled -> error
			string(REGEX REPLACE "\\." "" OpenCV_SHORT_VERSION ${OpenCV_VERSION})
			SET(OpenCV_LIBS "debug;opencv_imgproc${OpenCV_SHORT_VERSION}d;optimized;opencv_imgproc${OpenCV_SHORT_VERSION};debug;opencv_core${OpenCV_SHORT_VERSION}d;optimized;opencv_core${OpenCV_SHORT_VERSION};")
		endif()
	ENDIF()
	IF (NOT OpenCV_FOUND)
		message(FATAL_ERROR "OpenCV not found. It's mandatory when used with ENABLE_RAW enabled") 
	ELSE()
		add_definitions(-DWITH_OPENCV)
	ENDIF()
	
	
	if (APPLE)
		# OpenCV has really draconian dependencies on mac (generating bundle greater tha 105MB)
		# so I play bad games here - expecting all will work with manually updated library names
		message(STATUS "")
		message(STATUS "APPLE: some hacks with OpenCV libraries linking will be performed (only limited set of libs will be used)")
		message(STATUS "APPLE:    originals: ${OpenCV_LIBS}")
		set(OpenCV_LIBS "opencv_core;opencv_imgproc")
        	message(STATUS "APPLE:          new: ${OpenCV_LIBS}")
		message(STATUS "")
	endif (APPLE)

	# lanczos interpolation is not integrated in opencv 2.1 - all other things work
	IF(${OpenCV_VERSION} EQUAL "2.1.0")
		add_definitions(-DDISABLE_LANCZOS)
	ENDIF()

ENDIF()
	
include_directories (
	${QT_INCLUDES}
	${EXIV2_INCLUDE_DIRS}
	${LIBRAW_INCLUDE_DIRS}
	${OpenCV_INCLUDE_DIRS}
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_SOURCE_DIR}/src
)


set (NOMACS_SOURCES
        src/DkError.cpp
        src/DkImage.cpp
        src/DkMath.cpp
        src/DkConnection.cpp
        src/DkNetwork.cpp
        src/DkNoMacs.cpp
		src/DkPong.cpp
        src/DkTimer.cpp
        src/DkUtils.cpp
        src/DkViewPort.cpp
        src/DkWidgets.cpp
		src/DkDialog.cpp
        src/DkSettings.cpp
        src/BorderLayout.cpp
		src/DkTransferToolBar.cpp
        src/DkMenu.cpp
        src/main.cpp
)
if (APPLE)
	SET (NOMACS_SOURCES ${NOMACS_SOURCES} macosx/nomacs.icns)
endif (APPLE)


set (NOMACS_MOCS
        #src/DkError.h
        src/DkImage.h
        #src/DkMath.h
        src/DkConnection.h
        src/DkNetwork.h
        src/DkNoMacs.h
		src/DkPong.h
        #src/DkTimer.h
        #src/DkUtils.h
        src/DkViewPort.h
        src/DkWidgets.h
		src/DkDialog.h
        src/DkMenu.h
        src/DkSettings.h
		src/DkTransferToolBar.h
        #src/BorderLayout.h
        #src/resource.h
)

set (NOMACS_HEADERS
        src/DkError.h
        src/DkImage.h
        src/DkMath.h
        src/DkConnection.h
        src/DkNetwork.h
        src/DkNoMacs.h
		src/DkPong.h
        src/DkTimer.h
        src/DkUtils.h
        src/DkViewPort.h
        src/DkWidgets.h
		src/DkDialog.h
        src/DkMenu.h
        src/DkSettings.h
		src/DkTransferToolBar.h
        src/BorderLayout.h
        #src/resource.h
)

set (NOMACS_FORMS
        src/nomacs.ui
)

set (NOMACS_RESOURCES
        src/nomacs.qrc
)

set(NOMACS_TRANSLATIONS
		translations/nomacs_en.ts
		translations/nomacs_de.ts
		translations/nomacs_ru.ts
		translations/nomacs_zh.ts
		translations/nomacs_als.ts
)

if (MSVC) # some settings for visual studio
	SET(NOMACS_RC src/nomacs.rc) #add resource file when compiling with MSVC 
	SET(VERSION_LIB Version.lib)
	SET(EXIV2_LIBRARY_DIRS ${CMAKE_CURRENT_BINARY_DIR}/libs) #add libs directory to library dirs 
else(MSVC)
	SET(NOMACS_RC "")
	SET(VERSION_LIB "")
ENDIF(MSVC)

QT4_ADD_TRANSLATION(NOMACS_QM ${NOMACS_TRANSLATIONS})
QT4_WRAP_UI(NOMACS_UI ${NOMACS_FORMS})
QT4_WRAP_CPP(NOMACS_MOC_SRC ${NOMACS_MOCS})
QT4_ADD_RESOURCES(NOMACS_RCC ${NOMACS_RESOURCES})

#IF (EXIV2_FOUND AND LIBRAW_FOUND AND OpenCV_FOUND OR NOT COMPILEWITHOPENCV)
IF (EXIV2_FOUND)
	set(EXE_NAME ${CMAKE_PROJECT_NAME})
	link_directories(${LIBRAW_LIBRARY_DIRS} ${OpenCV_LIBRARY_DIRS} ${EXIV2_LIBRARY_DIRS})
	add_executable(${EXE_NAME} WIN32 MACOSX_BUNDLE ${NOMACS_SOURCES} ${NOMACS_UI} ${NOMACS_MOC_SRC} ${NOMACS_RCC} ${NOMACS_HEADERS} ${NOMACS_RC} ${NOMACS_QM} ${NOMACS_TRANSLATIONS})
	target_link_libraries(${EXE_NAME} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTNETWORK_LIBRARY} ${QT_QTMAIN_LIBRARY} ${EXIV2_LIBRARIES} ${LIBRAW_LIBRARIES} ${OpenCV_LIBS} ${VERSION_LIB})

	IF (CMAKE_SYSTEM_NAME MATCHES "Linux")
		SET_TARGET_PROPERTIES(${EXE_NAME} PROPERTIES LINK_FLAGS -fopenmp)
	ENDIF()

	IF (APPLE)
        	# mac's bundle install
	        SET_TARGET_PROPERTIES(${EXE_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_SOURCE_DIR}/macosx/Info.plist.in")
        	SET(MACOSX_BUNDLE_ICON_FILE nomacs.icns)

=== changelog ===
nomacs (0.4.0) unstable; urgency=low

  * Bug #135: translation files for linux
  * Bug #144: can't load nef file
  * Bug #148: image is moved to left lower corner in viewport
  * Bug #150: contrast tool crash
  * Bug #152: disable slideshow when end of directory is reached 
  *           and wrap images is off
  * Bug #131: hidden crop rectangle
  * Bug #136: end of dir
  * Bug #149: F5 does not update
  * Bug #151: subclassing DkWidget
  * Bug #154: crop tool - background is not filled correctly
  * Feature #137: preferences for caching
  * Feature #143: reopen widgets
  * Feature #147: How to save my setup?
  * Feature #112: Translate interface
  * Feature #127: snap cropping
  * Feature #145: Anzeige von weiteren RAW Formaten
   
 -- Stefan Fiel <stefan@nomacs.org>  Mon, 25 Jul 2012 11:00:15 +0200

nomacs (0.3.3) unstable; urgency=low

  * internal release

 -- Stefan Fiel <stefan@nomacs.org>  Thu, 21 May 2012 08:30:22 +0200

nomacs (0.3.2) unstable; urgency=low

  * Bug #128: restore old "open" dialog
  * Bug #129: Frameless for multiple monitors
  * Bug #130: rescaling transparent images
  * Bug #132: crop tool crops wrong area
  * Bug #133: resize
  * Feature: percent in resize dialogue
  * Feature: chinese translation
  * Feature: fast file indexing (for windows only)
 
 -- Stefan Fiel <stefan@nomacs.org>  Thu, 15 May 2012 15:10:22 +0200

nomacs (0.3.1) unstable; urgency=low

  * internal release

 -- Stefan Fiel <stefan@nomacs.org>  Thu, 10 May 2012 16:30:22 +0200
 

nomacs (0.3.0) unstable; urgency=low

  * Bug #55: performance loss when loading from network
  * Bug #97: toWCharArray
  * Bug #98: Absturz - Open With Dialog
  * Bug #99: nomacs.desktop: update mime types not to include directory
  * Bug #100: zoom 100%
  * Bug #110: date string bug
  * Bug #114: saving files
  * Bug #116: event echo
  * Bug #118: image loader
  * Bug #124: pseudo color function
  * Bug #125: slow start-up if network drive is mounted
  * Bug #126: thumbloader focus
  * Bug #128: restore old "open" dialog
  * Feature #13: Frameless
  * Feature #34: Bildwechsel mit Scrollrad
  * Feature #43: crop images
  * Feature #74: open with
  * Feature #93: add button to adjust windows size to image size
  * Feature #113: symbolic links
  * Feature: crop tool
  * Feature: image resize
  * Feature: pseudo color toolbar
  * Feature: new icons
  * Feature: translations

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 02 Mar 2012 17:30:22 +0200

nomacs (0.2.3) unstable; urgency=low

   * Bug #64: network - close connection
   * Bug #69: rating label
   * Bug #71: Network Server - not discoverable using vms
   * Bug #94: painter file info panel
   * Bug #95: save jpeg dialog ignores compression value
   * Feature #66: slideshow - player
   * Feature #67: display information (filenames)
   * Feature #68: silent loading
   * Feature #79: add showMenu, showToolbar and showStatusbar to Preferences
   * Feature #96: Format metadata

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 19 Dec 2011 08:22:22 +0200

nomacs (0.2.0) unstable; urgency=low

  * from alpha to beta

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 25 Oct 2011 15:22:22 +0200

nomacs (0.1.2) unstable; urgency=low

  * Initial release 

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 15 Aug 2011 08:49:22 +0200

=== control ===
Source: nomacs
Section: graphics
Priority: optional
Maintainer: Stefan Fiel <stefan@nomacs.org>
XSBC-Original-Maintainer: Stefan Fiel <stefan@nomacs.org>
Build-Depends: debhelper (>= 7.0.50~), cdbs (>= 0.4.90~), qt4-qmake, libqt4-dev, libexiv2-dev (>= 0.21.1~), libraw-dev (>= 0.13.1~), libcv-dev, libhighgui-dev, libcvaux-dev, cmake
Standards-Version: 3.9.3
Homepage: http://www.nomacs.org

Package: nomacs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: image viewer with capability of syncing multiple instances
 nomacs is a free image viewer for windows and linux systems, which is
 licensed under the GNU General Public License v3. nomacs is small, fast and 
 able to handle the most common image formats. Additionally it is possible to
 synchronize multiple viewers. A synchronization of viewers running on 
 the same computer or via LAN is possible. It allows one to compare images 
 and spot the differences (e.g. schemes of architects to show the 
 progress).
